#include <stdio.h>

#define MAX_SIZE 64

typedef unsigned int(*op_t)(unsigned int *, int);

void bad_func(int how_bad) {
    if (how_bad == 1337) {
        printf("Very bad.\n");
    } else {
        printf("Bad.\n");
    }
}

unsigned int xor(unsigned int *input, int n) {
    int i;
    unsigned int result = 0xFFFFFFFF;
    for (i = 0; i < n; i++) {
        result ^= input[i];
    }
    return result;
}

unsigned int and(unsigned int *input, int n) {
    int i;
    unsigned int result = 0xFFFFFFFF;
    for (i = 0; i < n; i++) {
        result &= input[i];
    }
    return result;
}

void choose_op(int op, op_t *f) {
    switch (op) {
        case '1':
            *f = xor;
            break;
        case '2':
            *f = and;
            break;
        default:
            *f = NULL;
    }
}

int main() {
    int op, n, i, r;
    op_t opfunc;
    unsigned int input[MAX_SIZE];

    //printf("%p %p\n", &opfunc, &(input[MAX_SIZE]));

    printf("Choose operation (1/2): ");
    op = fgetc(stdin);

    if (op != '1' && op != '2') {
        printf("Invalid choice (%d)!\n", op);
        return 1;
    }

    choose_op(op, &opfunc);
    
    printf("How many elements? ");
    scanf("%i", &n);
    
    printf("Enter %d integers: ", n); 
    i = 0;
    do {
        r = scanf("%u", &(input[i++]));
    } while (r != 0 && r != EOF && i <= n);
    
    printf("Result: 0x%x\n", opfunc(input, n));

    return 0;
}
